package pl.edu.pwr.examples;
import java.util.List;
import java.util.Properties;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.cfg.Configuration;
import org.hibernate.query.Query;
import org.hibernate.service.ServiceRegistry;
import org.hibernate.boot.registry.StandardServiceRegistryBuilder;
 
public class JpaDemo {
	private static SessionFactory sessionFactory = null;  
    private static ServiceRegistry serviceRegistry = null;  
       
    private static SessionFactory configureSessionFactory() throws HibernateException {  
    /*    Configuration configuration = new Configuration();  
        configuration.addAnnotatedClass(pl.edu.pwr.examples.Student.class);
        configuration.configure();  
         
        Properties properties = configuration.getProperties();
         
        serviceRegistry = new StandardServiceRegistryBuilder().applySettings(configuration.getProperties()).build();          
        sessionFactory = configuration.buildSessionFactory(serviceRegistry);  
         
      */  
        serviceRegistry = new StandardServiceRegistryBuilder()
                .configure("hibernate.cfg.xml")
                .build();

        sessionFactory = new Configuration().buildSessionFactory( serviceRegistry );
        
        
        
        return sessionFactory;  
    }
     
    public static void main(String[] args) {
     /* 
        // Configure the session factory
        configureSessionFactory();
        Session session = null;
        Transaction tx=null;
         
        try {
            session = sessionFactory.openSession();
            tx = session.beginTransaction();
             
            // Creating Contact entity that will be save to the sqlite database
            Student s1 = new Student("Jan", 1);
            Student s2 = new Student("Adam", 2);
            session.save(s1);
            session.save(s2);           
            // Committing the change in the database.
            session.flush();
            tx.commit();
             
            // Fetching saved data
            //List list = session.createQuery("Select p from " + Student.class.getName() + " p").list();
            // List list = session.createQuery("from " + Student.class.getName()).list();
            List list = session.createQuery("from Student").list();
            
            for (Object s : list) 
                System.out.println("Name:"  + ((Student)s).getName() + " | rollNo:" + ((Student)s).getRollNo());
             
            
            String hql = "UPDATE pl.edu.pwr.examples.Student set name = :name "  + 
                    "WHERE rollNo = :rollNo";
            tx = session.beginTransaction();
            Query query = session.createQuery(hql);
            query.setParameter("name", "Robert");
            query.setParameter("rollNo", 1);
            int result = query.executeUpdate();
            tx.commit();
            System.out.println("Rows affected: " + result);
            
        } catch (Exception ex) {
            ex.printStackTrace();
             
            // Rolling back the changes to make the data consistent in case of any failure 
            // in between multiple database write operations.
            tx.rollback();
        } finally{
            if(session != null) {
                session.close();
                System.out.println("END");
                if (serviceRegistry != null) {
                    StandardServiceRegistryBuilder.destroy(serviceRegistry );
                  }
            }
        }
        */
    	
        EntityManagerFactory entityManagerFactory = Persistence.createEntityManagerFactory("persistence");
		EntityManager entityManager = entityManagerFactory.createEntityManager();

		System.out.println("Starting Transaction");
		entityManager.getTransaction().begin();
		Student s1 = new Student("Witold",3);
		System.out.println("Saving Student to Database");
		entityManager.persist(s1);
		entityManager.getTransaction().commit();
//		System.out.println("Generated Employee ID = " + employee.getEmployeeId());

		// get an object using primary key.
		Student s2 = entityManager.find(Student.class, s1.getRollNo());
		System.out.println("got object " + s2.getName() + " " + s2.getRollNo());

		// get all the objects from Employee table
		@SuppressWarnings("unchecked")
		List<Student> listStudent = entityManager.createQuery("SELECT s FROM Student s").getResultList();

		if (listStudent == null) {
			System.out.println("No students found . ");
		} else {
			for (Student s : listStudent) {
				System.out.println("Student name= " + s.getName() + ", Student rollNo " + s.getRollNo());
			}
		}
		// remove and entity
		entityManager.getTransaction().begin();
		System.out.println("Deleting Student with rollNo = " + s2.getRollNo());
		entityManager.remove(s2);
		entityManager.getTransaction().commit();

		// close the entity manager
		entityManager.close();
		entityManagerFactory.close();

	}

}
